/* eslint-disable */
/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */


import { HTMLStencilElement, JSXBase } from './stencil.core';
import {
  AxisConfig,
  AxisConfigs,
  AxisDimension,
  CoordinateData,
  Dims,
  FormatType,
} from './types/types';

export namespace Components {
  interface AnjAxis {
    /**
    * Flags the axis as either the `"x"` or `"y"` axis. Default is x.
    */
    'dimension': AxisDimension;
    /**
    * Axis label formatting function, overrides default formatter derived from `type`
    */
    'formatter': (v) => string;
    'init': (svg: any, dims: Dims, data: CoordinateData[], axisConfigs: AxisConfigs, minMax: any, primarySeries?: any, y?: any) => Promise<any>;
    /**
    * Is the axis visible
    */
    'show': boolean;
    /**
    * If true will show the hashes in the axis (x only)
    */
    'ticks': boolean;
    /**
    * The data type of the axis. Options are: 'date' | 'number' | 'string' | 'percent' | 'currency';
    */
    'type': FormatType;
  }
  interface AnjChart {
    'currency': string;
    /**
    * By default, we would like to be able to interact with the popover and it's content. In some other cases we'd prefer to have mouse events penetrate the popover, and forfeit interacting with popover content
    */
    'disabledPopoverEvents': boolean;
    'locale': string;
  }
  interface AnjPopoverContentMulti {}
  interface AnjPopoverContentSingle {}
  interface AnjSeries {
    /**
    * If true will render an area for single line series only
    */
    'area': boolean;
    /**
    * The display color of the series. If none is chosen it will be assigned based on design system defaults.
    */
    'color': string;
    /**
    * Array of coordinates in {x, y} format for the series.
    */
    'data': CoordinateData[];
    'init': (svg: any, x: any, y: any, data: CoordinateData[], index: number, dims: any, multiSeries?: any, secondaryIndex?: number) => Promise<any>;
    /**
    * The display label for the series.
    */
    'name': string;
    /**
    * The series display type. Options are `"column"`, `"line"`, `"pie"`, `"scatter"` and `"stacked-column"`.
    */
    'type': 'column' | 'line' | 'pie' | 'scatter' | 'stacked-column';
  }
}

declare global {


  interface HTMLAnjAxisElement extends Components.AnjAxis, HTMLStencilElement {}
  var HTMLAnjAxisElement: {
    prototype: HTMLAnjAxisElement;
    new (): HTMLAnjAxisElement;
  };

  interface HTMLAnjChartElement extends Components.AnjChart, HTMLStencilElement {}
  var HTMLAnjChartElement: {
    prototype: HTMLAnjChartElement;
    new (): HTMLAnjChartElement;
  };

  interface HTMLAnjPopoverContentMultiElement extends Components.AnjPopoverContentMulti, HTMLStencilElement {}
  var HTMLAnjPopoverContentMultiElement: {
    prototype: HTMLAnjPopoverContentMultiElement;
    new (): HTMLAnjPopoverContentMultiElement;
  };

  interface HTMLAnjPopoverContentSingleElement extends Components.AnjPopoverContentSingle, HTMLStencilElement {}
  var HTMLAnjPopoverContentSingleElement: {
    prototype: HTMLAnjPopoverContentSingleElement;
    new (): HTMLAnjPopoverContentSingleElement;
  };

  interface HTMLAnjSeriesElement extends Components.AnjSeries, HTMLStencilElement {}
  var HTMLAnjSeriesElement: {
    prototype: HTMLAnjSeriesElement;
    new (): HTMLAnjSeriesElement;
  };
  interface HTMLElementTagNameMap {
    'anj-axis': HTMLAnjAxisElement;
    'anj-chart': HTMLAnjChartElement;
    'anj-popover-content-multi': HTMLAnjPopoverContentMultiElement;
    'anj-popover-content-single': HTMLAnjPopoverContentSingleElement;
    'anj-series': HTMLAnjSeriesElement;
  }
}

declare namespace LocalJSX {
  interface AnjAxis {
    /**
    * Flags the axis as either the `"x"` or `"y"` axis. Default is x.
    */
    'dimension'?: AxisDimension;
    /**
    * Axis label formatting function, overrides default formatter derived from `type`
    */
    'formatter'?: (v) => string;
    /**
    * Emitted when the axis loads
    */
    'onAnjAxisDidLoad'?: (event: CustomEvent<AxisConfig>) => void;
    /**
    * Is the axis visible
    */
    'show'?: boolean;
    /**
    * If true will show the hashes in the axis (x only)
    */
    'ticks'?: boolean;
    /**
    * The data type of the axis. Options are: 'date' | 'number' | 'string' | 'percent' | 'currency';
    */
    'type'?: FormatType;
  }
  interface AnjChart {
    'currency'?: string;
    /**
    * By default, we would like to be able to interact with the popover and it's content. In some other cases we'd prefer to have mouse events penetrate the popover, and forfeit interacting with popover content
    */
    'disabledPopoverEvents'?: boolean;
    'locale'?: string;
    /**
    * Emitted when the use hovers over a data point or series of them
    */
    'onAnjHover'?: (event: CustomEvent<CoordinateData[]>) => void;
  }
  interface AnjPopoverContentMulti {}
  interface AnjPopoverContentSingle {}
  interface AnjSeries {
    /**
    * If true will render an area for single line series only
    */
    'area'?: boolean;
    /**
    * The display color of the series. If none is chosen it will be assigned based on design system defaults.
    */
    'color'?: string;
    /**
    * Array of coordinates in {x, y} format for the series.
    */
    'data'?: CoordinateData[];
    /**
    * The display label for the series.
    */
    'name'?: string;
    /**
    * Emitted when a series has loaded or prop has updated
    */
    'onAnjSeriesDidLoad'?: (event: CustomEvent<void>) => void;
    /**
    * Emitted when a series has unloaded
    */
    'onAnjSeriesDidUnload'?: (event: CustomEvent<void>) => void;
    /**
    * Emitted when a pie series has updated
    */
    'onAnjSeriesDidUpdate'?: (event: CustomEvent<any>) => void;
    /**
    * The series display type. Options are `"column"`, `"line"`, `"pie"`, `"scatter"` and `"stacked-column"`.
    */
    'type'?: 'column' | 'line' | 'pie' | 'scatter' | 'stacked-column';
  }

  interface IntrinsicElements {
    'anj-axis': AnjAxis;
    'anj-chart': AnjChart;
    'anj-popover-content-multi': AnjPopoverContentMulti;
    'anj-popover-content-single': AnjPopoverContentSingle;
    'anj-series': AnjSeries;
  }
}

export { LocalJSX as JSX };


declare module "@stencil/core" {
  export namespace JSX {
    interface IntrinsicElements {
      'anj-axis': LocalJSX.AnjAxis & JSXBase.HTMLAttributes<HTMLAnjAxisElement>;
      'anj-chart': LocalJSX.AnjChart & JSXBase.HTMLAttributes<HTMLAnjChartElement>;
      'anj-popover-content-multi': LocalJSX.AnjPopoverContentMulti & JSXBase.HTMLAttributes<HTMLAnjPopoverContentMultiElement>;
      'anj-popover-content-single': LocalJSX.AnjPopoverContentSingle & JSXBase.HTMLAttributes<HTMLAnjPopoverContentSingleElement>;
      'anj-series': LocalJSX.AnjSeries & JSXBase.HTMLAttributes<HTMLAnjSeriesElement>;
    }
  }
}


