import { EventEmitter } from '../../stencil.core';
import { CoordinateData } from '../../types/types';
export declare class Series {
    /**
     * If true will render an area for single line series only
     */
    area: boolean;
    /**
     * The display color of the series. If none is chosen it will be assigned based on design system defaults.
     */
    color: string;
    /**
     * Array of coordinates in {x, y} format for the series.
     */
    data: CoordinateData[];
    /**
     * The display label for the series.
     */
    name: string;
    /**
     * The series display type.
     * Options are `"column"`, `"line"`, `"pie"`, `"scatter"` and `"stacked-column"`.
     */
    type: 'column' | 'line' | 'pie' | 'scatter' | 'stacked-column';
    /**
     * Emitted when a series has loaded or prop has updated
     */
    anjSeriesDidLoad: EventEmitter<void>;
    /**
     * Emitted when a pie series has updated
     */
    anjSeriesDidUpdate: EventEmitter<any>;
    /**
     * Emitted when a series has unloaded
     */
    anjSeriesDidUnload: EventEmitter<void>;
    componentDidLoad(): void;
    componentDidUnload(): void;
    componentDidUpdate(): void;
    init(svg: any, x: any, y: any, data: CoordinateData[], index: number, dims: any, multiSeries?: any, secondaryIndex?: number): Promise<any>;
    private column;
    private line;
    private scatter;
    private pie;
    private stackedColumn;
}
