import { Area, Line, ScaleLinear, Selection } from '../d3-bundle';
import { AxisConfigs, CoordinateData, Dims, IndexQuery, PointOptions, SeriesType, TimeInterval } from '../types/types';
export declare class ChartD3Service {
    protected static animationLength: number;
    protected static focusLength: number;
    private static yPad;
    private static groupPadding;
    static addArea(svg: any, line: any, y: any, data: CoordinateData[], color: string): Area<any>;
    static addStackedColumn(svg: any, x: any, y: any, data: CoordinateData[], color: string): any;
    static addColumn(svg: any, x: any, x1: any, y: any, data: CoordinateData[], color: string, _dims: Dims, index: any): any;
    static addPie(svg: any, data: any, dims: any): any;
    static addLine(svg: any, x: any, y: any, data: CoordinateData[], color: string, secondary?: boolean): Line<any>;
    static addOverlay(svg: any, dims: Dims): SVGRectElement;
    static addPoints(svg: any, x: any, y: any, data: CoordinateData[], color: string, index: any, options?: PointOptions): void;
    static addRevealAnimation(svg: any, dims: Dims, axisConfigs: AxisConfigs, data: any): SVGRectElement;
    static addStackedScrubbers(svg: any, x: any, data: CoordinateData[], dims: any, index: any): void;
    static addScrubbers(svg: any, x: any, data: CoordinateData[], dims: any, index: any): void;
    static getX1(x: any, data: any, multiSeries: any): any;
    static getBaselineXAxis(dims: any, data: any, primarySeries: any, x: any, interval: any): any;
    static addXAxis(svg: any, dims: any, data: any, axisConfigs: AxisConfigs, _minMax: any, primarySeries: any, y: any): any;
    static axisTyper(type: SeriesType, data: any, dims: any): any;
    static calculatePadding(data: any[], dims: any): number;
    static addYAxis(svg: any, dims: any, data: CoordinateData[], axisConfigs: AxisConfigs, minMax?: {
        min: number;
        max: number;
    }): ScaleLinear<number, number>;
    static createSVG(dims: Dims): Selection<SVGGElement, any, SVGElement, any>;
    static getIndexOfClosestPoint(x: any, data: any): number;
    static getIndexOfClosestBar(x: any, data: any): IndexQuery;
    static getIndexOfClosestMultiSeriesBar(x: any, data: any): IndexQuery;
    static getIndexOfClosestSingleSeriesBar(x: any, data: any): IndexQuery;
    static hideFocus(svg: any): void;
    static setPieNav(header: any, parentName: any, childName?: any): any;
    static showFocus(svg: any, activeIndex: any): void;
    static renderSlices(g: any, pie: any, arc: any, data: any): any;
    private static calculateLeftPad;
    private static calculateTicks;
    static formatDataAsStacked(rawData: any): import("d3-shape").Series<{
        [key: string]: number;
    }, string>[];
    static seriesAsStackFormat(series: any[]): any;
    static stackOffsetDiverging(series: any, seriesOrder: number[]): void;
    static timeTickEvery(interval: TimeInterval): import("d3-time").TimeInterval;
}
